/*  File:   main.c 1
 * gakufu ́A16 bit P 
 *   p[gṔAŏɃe|(1Ԃɉtl̐jL^B
 *   ̑̃p[g ̃p[g̉ʁiO|PQVjL^B
 *           p[gP̉ʂ͏ɍőiPQVj
 * ȍ~͉ MSB 8 bit̍B PʂŁÃh 60(0x3C)
 *                LSB 7 bit̒
 *     񕪉F10A    lF08A    F04A    \ZF02
 * t_񕪉F18At_lF0CAt_F06At_\ZF03
 *      | 7 6 5 4 3 2 1 0| 7 6 5 4 3 2 1 0 |
 *      |            |  |          |
 * 
 *     Language: MPLABX XC8   Target: PIC116F1459
 * 20210410 rev1 : xc8 ver 2.20 ɑΉ
 */

// x  wl(ms)1/16
#define EnvelopeConst 50
// Ɖ̊Ԃ̖(ms)
#define SilentTime    30

#include "xc.h"
#include "gakufu.h"
#define _XTAL_FREQ 48000000
#define SW2        RA5
#define p1         0
#define p2         1
#define p3         2
#define p4         3
#define waitStart  0
#define getGakufu  1
#define getOnpu    2
#define onpuStart  3
#define onpuPlay   4
#define onpuLast   5
#define onpuEnd    6
#define gkfEnd     7

#pragma config FOSC  = INTOSC, WDTE = OFF, PWRTE = OFF, MCLRE = OFF, CP  = OFF
#pragma config BOREN = ON, CLKOUTEN = OFF, IESO  = OFF, FCMEN = OFF
#pragma config WRT = OFF, CPUDIV = NOCLKDIV, USBLSCLK = 48MHz, PLLMULT = 3x
#pragma config PLLEN = ENABLED, STVREN = ON, BORV = LO, LPBOR = OFF, LVP = OFF

const unsigned int dW_tbl[] = {     // for 48MHz  PWM Freq 93.75kHzx4
//  Do,   Do#,  Re,   Re#,  Mi,   Fa,   Fa#,  So,   So#,  Ra,   Ra#,  Si,
    0,
    0x0B7,0x0C2,0x0CD,0x0D9,0x0E6,0x0F4,0x103,0x112,0x122,0x134,0x146,0x159, //12
    0x16E,0x184,0x19B,0x1B3,0x1CD,0x1E8,0x205,0x224,0x245,0x267,0x28C,0x2B2, //24
    0x2DC,0x307,0x335,0x366,0x39A,0x3D0,0x40B,0x448,0x489,0x4CE,0x517,0x565, //36
    0x5B7,0x60E,0x66A,0x6CC,0x733,0x7A1,0x815,0x890,0x913,0x99D,0xA2F,0xACA, //48
    0xB6E, 0xC1C, 0xCD5, 0xD98, 0xE67, 0xF42, 0x102A,0x1120,0x1225,0x1339,0x145E,0x1594, //60
    0x16DC,0x1838,0x19A9,0x1B30,0x1CCE,0x1E84,0x2055,0x2241,0x244A,0x2673,0x28BC,0x2B28, //72
};  // 0x5B7(index 37) S̃h(60 0x3E) ,0x99D ̓ (440Hz)

unsigned int accWave[] = {0,0,0,0};
unsigned int incWave[] = {0,0,0,0};
unsigned char amp[]  = {0,0,0,0};
unsigned char wave[] = {0,0,0,0};
char SWdown=0;                     // SW tO
char TmpCnt;                       // e|ԃJEg 
char SltCnt;                       // ԃJEg 
unsigned char tempo;               // 16̎ ms 
char TmpFlg[] = {0,0,0,0};         // e| tO
char SltFlg[] = {0,0,0,0};         //  tO
char EnvCnt[] = {1,1,1,1};         // UԃJEg

// vg^Cv
void SWcheck(void);
void EnvelopeCnt(char);
void TempoCnt(void);
void SilentCnt(void);
void Control(char);
unsigned int ReadOnp(char,unsigned int);

void main(void) {       
    OSCCON = 0b11111100;     // SPLLEN = ON, 16MHz(x3=48MHz)
    TRISC = 0b10110000;      // PWM2,LEDs o͐ݒ
    LATC = 0;                // LEDs 
    nWPUEN = 0;              // vAbv L
    // Timer1 ̐ݒ -------------------------
    T1CON = 0b00000001;                 // Fosc/4 ps 1/1 TMR1ON
    TMR1 = 0xD100;                      // +12032 (1ms)  Carry
    TMR1IF = 0;                         // Timer1tONA
    // PWM ̐ݒ -------------------------
    PWM2DCL = 0;
    PR2 = 0x7F;                         // Freq_PWM = 93.75kHz
    T2CON = 0b00000000;                 // Fosc/4 ps 1/1 T2OFF
    TMR2IF = 0;                         // Timer2tONA
    TMR2IE = 1;                         // Timer2ݗL
    PEIE = 1;                           // ytFݗL
    GIE = 1;                            // ݗL
    while(1){
        if(TMR1IF){                        // 1ms  Carry
            TMR1H = 0xD1;                  //  1ms ݒ
            TMR1IF = 0;
            SWcheck();                     // SW ON̊mF
            EnvelopeCnt(p1);               // U 50ms
            EnvelopeCnt(p2);               // U 50ms
            TempoCnt();                    // e|
            SilentCnt();                   // 
        }
        Control(p1);                       // Part1 o͐
        Control(p2);                       // Part2 o͐
        Control(p3);                       // Part1 o͐
        Control(p4);                       // Part2 o͐
    }   //  while
}
// ݏu --------------------------------------------
void __interrupt() isr(void){
    static char ch;
    if(TMR2IF){                             // Timer2 ݂mF
        TMR2IF = 0;                         // Timer2 tO@Zbg
        ch++;                               // o͂Partԍi߂
        ch &= 3;                            // ԍ͂O|R܂
        accWave[ch] += incWave[ch];         // partJԂg`XV
        if(STATUSbits.CARRY)wave[ch] ^= 1;  // LoΔ]
        if(wave[ch])PWM2DCH = amp[ch];      // g` Hi Ȃamp
        else PWM2DCH = 0;                   // g` Low Ȃ[
    }                                       // TCNŏo
}
//------- SW`^Oh~ 1ms[v ----------------
void SWcheck(void){
    static char SWnotRdy = 10;              // SWup̊mF҂
    if(SWnotRdy){                           // SWup̊mFȂ
        if(SW2)SWnotRdy--;                  //   SWup̊mF[P
        else SWnotRdy = 10;                 //   SWup̊mFl
    }else if(!SW2){                         // SWup̊mFς݂DownȂ
        SWdown = 1;                         //   SWꂽ}[N
        SWnotRdy = 10;                      //   SWup̊mF҂
    }
}
//------- U 50ms -----------------------------------
void EnvelopeCnt(char pt){
    if(EnvCnt[pt]-- == 1){
        EnvCnt[pt] = EnvelopeConst;         // 50ms
        amp[pt] = (int)amp[pt] * 15/16;     // ʂ -6% 
    }
}
//------- e| -----------------------------------
void TempoCnt(void){
    if(TmpCnt-- == 1){
        TmpCnt = tempo;                     // e|
        TmpFlg[p1] = 1;                     // e|tOZbg
        TmpFlg[p2] = 1;
        TmpFlg[p3] = 1;
        TmpFlg[p4] = 1;
    }
}
//-------  -----------------------------------
void SilentCnt(void){
    if(SltCnt-- == 1){                      // ԂɂȂ
        SltFlg[p1] = 1;                     // tOZbg
        SltFlg[p2] = 1;
        SltFlg[p3] = 1;
        SltFlg[p4] = 1;
    }
}
//------- 吧 -----------------------------------
void Control(char pt){
    static char state[] = {0,0,0,0};
    static int  pOnp[]  = {0,0,0,0};        // ʒu
    static unsigned char iAmp[4];           // p[g̉
    static unsigned char tPlay[4];          // t
    static unsigned int  incNext[4];        //  
    static unsigned char ampNext[4];        //  
    unsigned int Onp;
    char i;
    //---------------------------------------------------------
    switch(state[pt]){
        case waitStart:             // ====== tJn҂ ======
            if(SWdown){                          // SW ̂҂
                if(pt == p1){                    // Part1
                    SWdown=0;                    //  SW ςݖ
                    state[p1] = getGakufu;       //  tJn
                }
            }
            break;
        case getGakufu:             // ====== y̐ݒ ======
            if(p1gkf[pOnp[p1]]==0xFFFF){         // yI[Ȃ
                for(i=0;i<=3;i++){               //   Sp[g̊y
                    pOnp[i] = 0;                 //   擪ɃZbg
                }
            }
            tempo = 7500/p1gkf[pOnp[p1]];        // ỹe|擾
            TmpCnt = tempo;                      // e|Zbg
            PWM2CON = 0b11000000;                // PWM ON
            TMR2ON = 1;                          // Timer2 ON
            for(i=0;i<=3;i++){                   // Sp[g
                iAmp[i] = ReadOnp(i, pOnp[i]++); //   ʎ擾
                TmpFlg[i] = 0;                   //   e|tOZbg
                state[i] = getOnpu;              //   ݒ
            }
            iAmp[p1] = 0x7F;                     // Part1 ʂ͏ɍő
            break;
        case getOnpu:               // ====== ̐ݒ ======
            Onp = ReadOnp(pt, pOnp[pt]++);       // Yy特擾
            if(Onp == 0xFFFF){                   // Part̏IȂ
                state[pt] = gkfEnd;              //   ȏI
                break;
            }
            tPlay[pt] = Onp & 0x7F;              // tԂɕϊ
            Onp = Onp >> 8;                      // ̍o
            if((Onp>23)&(Onp<96)){               // Ȃ
                incNext[pt] = dW_tbl[Onp - 23];  //   JԂԂɕϊ
                ampNext[pt] = iAmp[pt];          //   ő剹
            }else{                               // xȂ
                incNext[pt] = 0;                 //   JԂ@Ȃ
                ampNext[pt] = 0;                 //   OFF
            }
            state[pt] = onpuStart;               // tJn
            break;
        case onpuStart:             // ====== ̉tJn ======
            if(TmpFlg[pt]){                      // e|҂
                TmpFlg[pt] = 0;                  // ̉tXV
                incWave[pt] = incNext[pt];       // JԂPʃZbg
                accWave[pt] = 0;                 // g`JԂZbg
                wave[pt] = 0;                    // g` OFF
                EnvCnt[pt] = EnvelopeConst;      // ʌ^C}Zbg
                amp[pt] = ampNext[pt];           // ʃZbg
                if(amp[pt])LATC |= 1 << pt;      // ȂLED_
                state[pt] = onpuPlay;            // tp
            }
            break;
        case onpuPlay:             // ====== ̉tp ======
            if(TmpFlg[pt]){                      // e|҂
                TmpFlg[pt] = 0;                  // e|tOZbg
                if(tPlay[pt]-- == 2)             // ̉tIȂ
                    state[pt] = onpuLast;        //   ̖ݒ
                if(SWdown){                      // SW
                    state[p1] = gkfEnd;          //   Ȃ̏I
                    SWdown=0;                    //   SW ςݖ
                }
            }
            break;
        case onpuLast:             // ====== ̖Ԑݒ ======
            LATC &= ~(1 << pt);                  // LED OFF
            SltCnt = tempo - SilentTime;         // ԂZbg
            SltFlg[pt] = 0;                      // tOZbg
            state[pt] = onpuEnd;                 // ̎ԏI
            break;
        case onpuEnd:             // ====== ̉tI ======
            if(SltFlg[pt]){                      // tIԂ҂
                amp[pt] = 0;                     // OFF
                state[pt] = getOnpu;             // ̉擾
            }
            break;
        case gkfEnd:              // ====== ỷtI ======
            if(pt == p1){                        // Part 1 IȂ
                LATC &= 0xF0;                    //     LED
                PWM2CON = 0;                     //     PWM OFF
                TMR2ON = 0;                      //     Timer2 OFF
                for(i=0;i<=3;i++){               //     SPartƂ
                    pOnp[i]--;                   //       ȏI܂Ői
                    while(ReadOnp(i, pOnp[i]++) != 0xFFFF);
                    state[i] = waitStart;        //       tJn҂
                }
            }else{                               // Part 1 ȊOȂ
                amp[pt] = 0;                     //   YOFF
                incWave[pt] = 0;                 //   JԂP O
                state[pt] = waitStart;           //   ȉt҂
            }
            break;
    }
}
// w part ̊yw index ̉擾
unsigned int ReadOnp(char part, unsigned int index){
    switch(part){ 
        case p1:return p1gkf[index];
        case p2:return p2gkf[index];
        case p3:return p3gkf[index];
        case p4:return p4gkf[index];
    }
    return 0;
}